<Manage::FieldContainer
  @title={{t 'attributes'}}
  @isDisabled={{@isDisabled}}
  @isSaveDisabled={{this.isDisabled}}
  @editablePanel={{@editablePanel}}
  @onEdit={{@onEdit}}
  @onSave={{this.save}}
  @onCancel={{this.cancel}}
  class='container-group-attributes'
  ...attributes
>
  <:view>
    {{#each @value as |attribute|}}
      <div class='input-icon-attribute mb-3'>
        <div class='attribute-name'>
          <strong>{{attribute.name}}</strong>
          {{#if attribute.isInherited}}
            <span class='icon-inherited' title={{t 'inherited attribute'}}>
              <FaIcon @icon='code-branch' />
            </span>
          {{/if}}
          <VisibilityIcon @value={{not attribute.isPrivate}} />
        </div>
        <div class='attribute-type'>
          {{attribute.type}}
        </div>
      </div>
    {{else}}
      <div class='alert alert-info' role='alert'>
        {{t 'icon-missing-attributes-message'}}
      </div>
    {{/each}}
  </:view>

  <:edit>
    <DragSortList
      @isHorizontal={{false}}
      @items={{this.value}}
      @dragEndAction={{this.dragEnd}}
      @handle='.handler'
      as |attribute index|
    >
      <div class='input-icon-attribute d-flex'>
        <div class='handler drag-handler' draggable='true'>
          <FaIcon @icon='arrows-alt-v' />
        </div>
        <div class='flex-grow-1'>
          <div class='d-flex w-100 align-items-end mb-2'>
            <div class='me-2'>
              <label
                for='{{this.elementId}}-attribute-name-{{index}}'
                class='form-label'
              >
                {{capitalize (t 'name')}}
              </label>
              <Input
                @value={{attribute.name}}
                id='{{this.elementId}}-attribute-name-{{index}}'
                disabled={{attribute.isInherited}}
                class='form-control input-attribute-name'
              />
            </div>

            <div class='me-2'>
              <label
                for='{{this.elementId}}-attribute-display-name-{{index}}'
                class='form-label'
              >
                {{capitalize (t 'display name')}}
              </label>
              <Input
                @value={{attribute.displayName}}
                id='{{this.elementId}}-attribute-display-name-{{index}}'
                class='form-control input-attribute-display-name'
              />
            </div>

            <div class='me-2 flex-grow-1'>
              <label
                for='{{this.elementId}}-attribute-help-{{index}}'
                class='form-label'
              >
                {{capitalize (t 'help message')}}
              </label>
              <Input
                @value={{attribute.help}}
                id='{{this.elementId}}-attribute-help-{{index}}'
                class='form-control input-attribute-help'
              />
            </div>

            <div>
              <button
                type='button'
                class='btn btn-danger btn-delete'
                disabled={{attribute.isInherited}}
                {{on 'click' (fn this.deleteItem index)}}
              >
                <FaIcon @icon='trash' />
              </button>
            </div>
          </div>

          <div class='d-flex w-100 align-items-end mb-2'>
            <div class='me-2'>
              <label
                for='{{this.elementId}}-attribute-type-{{index}}'
                class='form-label'
              >
                {{capitalize (t 'type')}}
              </label>
              <Input::Select
                @list={{this.types}}
                @value={{attribute.type}}
                @onChange={{fn this.attributeTypeChanged index}}
                id='{{this.elementId}}-attribute-type-{{index}}'
              />
            </div>

            {{#if (eq attribute.optionsType 'text')}}
              <div class='flex-grow-1'>
                <label
                  for='{{this.elementId}}-attribute-options-{{index}}'
                  class='form-label'
                >
                  {{t 'attributes-options-label'}}
                </label>
                <Input
                  @value={{attribute.options}}
                  id='{{this.elementId}}-attribute-options-{{index}}'
                  class='form-control input-attribute-options'
                />
              </div>
            {{/if}}
          </div>

          <div class='d-flex w-100 align-items-end'>
            <div class='form-check form-switch mb-2'>
              <Input
                class='form-check-input input-is-attribute-private'
                id='{{this.elementId}}-is-private-{{index}}'
                @checked={{attribute.isPrivate}}
                @type='checkbox'
              />

              <label
                class='form-check-label'
                for='{{this.elementId}}-is-private-{{index}}'
              >{{capitalize (t 'is private')}}</label>
            </div>
          </div>

          <div class='d-flex w-100 align-items-end mb-2'>
            <div class='form-check form-switch mb-4'>
              <Input
                class='form-check-input input-is-attribute-required'
                id='{{this.elementId}}-is-required-{{index}}'
                @checked={{attribute.isRequired}}
                @type='checkbox'
              />

              <label
                class='form-check-label'
                for='{{this.elementId}}-is-required-{{index}}'
              >{{capitalize (t 'is required')}}</label>
            </div>
          </div>

        </div>
      </div>
    </DragSortList>

    <button
      type='button'
      class='btn btn-outline-primary btn-add-attribute mt-3'
      {{on 'click' this.addAttribute}}
    >
      <FaIcon @icon='plus' />&nbsp;{{t 'attribute'}}
    </button>
    <div class="d-none" {{did-insert this.setup}}></div>
  </:edit>
</Manage::FieldContainer>